<?php
/*------------------------------------------------------------------------
# plg_approvenotify
# ------------------------------------------------------------------------
# Jacarlin Web Studio
# copyright Copyright (C) 2012 jacarlin.com.my. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.jacarlin.com.my
# Technical Support:  Forum - http://www.jacarlin.com.my/forum/
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die ('Restricted access');

jimport('joomla.plugin.plugin');
JLoader::register('K2Parameter', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2parameter.php');
$document =JFactory::getDocument();
$document->addStyleSheet(JURI::root() . 'plugins/k2/approveandnotify/style.css');


/**
 * Example K2 Plugin to render approveandnotify URLs entered in backend K2 forms to video players in the frontend.
 */

class plgK2approveandnotify extends JPlugin {

	// Some params
	var $pluginName = 'approveandnotify';
	var $pluginNameHumanReadable = 'Notify Admin by email of submissions';
 // var $_currentAction;

	function plgK2approveandnotify( & $subject, $params){
		parent::__construct($subject, $params);
	}



	/**
	* Below we list all available FRONTEND events, to trigger K2 plugins.
	* Watch the different prefix "onK2" instead of just "on" as used in Joomla! already.
	* Most functions are empty to showcase what is available to trigger and output. A few are used to actually output some code for example reasons.
	*/

  function onContentPrepareForm($form, $data)
	{
    // die;

  }
	function onK2PrepareContent( &$item, &$params, $limitstart ){

	}
  
	
	function onK2AfterDisplay( &$item, &$params, $limitstart ){
		return;
	}
	
	function onK2BeforeDisplay( &$item, &$params, $limitstart ){
		

    return;
	}
	
	function onK2AfterDisplayTitle( &$item, &$params, $limitstart ){
		return;
	}
	
	function onK2BeforeDisplayContent( &$item, &$params, $limitstart ){
		
    return;
	}
	
	function onK2AfterDisplayContent( & $item, & $params, $limitstart){

    return;
	}


	
	// Event to display in the frontend the approveandnotify URL as entered in the user form
	function onK2UserDisplay( &$user, &$params, $limitstart ){
                return;
	}

	
  function onRenderAdminForm(&$item, $type, $tab = '')
    {

        $mainframe = JFactory::getApplication();
         if ($mainframe->isAdmin()) {
        $plugin = &JPluginHelper::getPlugin('k2', $this->pluginName);
        $pluginParams = new JParameter($plugin->params);

      // Get the output of the K2 plugin fields (the data entered by your site maintainers)
    	  $plugins = new K2Parameter($item->plugins, '', $this->pluginName);

        $videoURL = $plugins->get('k2_user_name_plugins');
       // echo "videoURL : ".$videoURL;
        
       
        $manifest = (K2_JVERSION == '15') ? JPATH_SITE.DS.'plugins'.DS.'k2'.DS.$this->pluginName.'.xml' : JPATH_SITE.DS.'plugins'.DS.'k2'.DS.$this->pluginName.DS.$this->pluginName.'.xml';
       // echo "manif :  ".$manifest;
        if (!empty($tab))
        {
            $path = $type.'-'.$tab;
        }
        else
        {
            $path = $type;
        }
        if (!isset($item->plugins))
        {
            $item->plugins = NULL;
        }
        if (K2_JVERSION == '30')
        {
            jimport('joomla.form.form');
            $form = JForm::getInstance('plg_k2_'.$this->pluginName.'_'.$path, $manifest, array(), true, 'fields[@group="'.$path.'"]');
            
            $values = array();
            if ($item->plugins)
            {
                foreach (json_decode($item->plugins) as $name => $value)
                {
                    $count = 1;
                    $values[str_replace($this->pluginName, '', $name, $count)] = $value;
                    
                }
                $form->bind($values);
            }
            $fields = '';
            foreach ($form->getFieldset() as $field)
            {
                $search = 'name="'.$field->name.'"';
                $replace = 'name="plugins['.$this->pluginName.$field->name.']"';
                $input = JString::str_ireplace($search, $replace, $field->__get('input'));
                $fields .= $field->__get('label').' '.$input;
            }
            
        }
        else
        {
            $form = new K2Parameter($item->plugins, $manifest, $this->pluginName);        
            $fields = $form->render('plugins', $path);
            jimport( 'joomla.access.access' );
              $coaches = JAccess::getUsersByGroup(8);

              $currentuser =& JFactory::getUser();
              $usergroups = $currentuser->getAuthorisedGroups();
              $isAdmin = in_array(8, $usergroups);                                        
               if($isAdmin){
                 // managers users
                 $authors = JAccess::getUsersByGroup(6);
               }else {
                 // authors user
                 $authors = JAccess::getUsersByGroup(3);
               }
              
              jimport( 'joomla.user.user' );
              $emails = Array();

              $output = '<div id="my_admins"><table class="paramlist admintable" cellspacing="1">';
              $output .= "<tr>";
              $output .= "<td class='paramlist_key'>";
              $output .= "Admins";
              $output .= "</td>";
              $output .= "<td class='paramlist_value'>";
//              $output .= "<input type='hidden' name='userAdmin' id='userAdmin' value='$item->created_by'>";
              $output .= "<select name='k2_user_name_plugins' id='k2_user_name_plugins'>";
              foreach($coaches as $coache){
                $userFind = & JFactory::getUser($coache);
                 $selected = ($userFind->id == $item->created_by) ? "selected" : "";

                 $output .= "<option $selected value='$userFind->id'>";
                 $output .= $userFind->username;
                 $output .= "</option>";

              }
              $output .= "</select>";

             

              
              $output .= "</td>";
              $output .= "</tr>";
              $output .= "</table></div>";


               $output .= '<div id="my_authors"><table class="paramlist admintable" cellspacing="1">';
              $output .= "<tr>";
              $output .= "<td class='paramlist_key'>";
              $output .= "Users ";
              $output .= "</td>";
              $output .= "<td class='paramlist_value'>";
//              $output .= "<input type='hidden' name='userAdmin' id='userAdmin' value='$item->created_by'>";
              $output .= "<select name='k2_user_namereject_plugins' id='k2_user_namereject_plugins'>";

               foreach($authors as $author){
                $userFind = & JFactory::getUser($author);
                 $selected = ($userFind->id == $item->created_by) ? "selected" : "";

                 $output .= "<option $selected value='$userFind->id'>";
                 $output .= $userFind->username;
                 $output .= "</option>";

              }

              $output .= "</select>";

              $output .= "</td>";
              $output .= "</tr>";
              $output .= "</table></div>";


              $output .= "<script language=\"javascript\">";
              $output .= "
                        jQuery(document).ready(function() {
                       
                          if (jQuery('#pluginsapproveandnotifyaction_name_plugins').val() == '')
                          {
                            jQuery('#my_admins').hide();
                            jQuery('#my_authors').hide();
                          }
                          else {
                            if (jQuery('#pluginsapproveandnotifyaction_name_plugins').val() == 'approve') {
                            jQuery('#my_admins').show();
                            jQuery('#my_authors').hide();
                           }
                           else {
                            if (jQuery('#pluginsapproveandnotifyaction_name_plugins').val() == 'reject') {
                            jQuery('#my_admins').hide();
                            jQuery('#my_authors').show();
                            }
                          }
                         }
                        });


                        jQuery('#pluginsapproveandnotifyaction_name_plugins').change(function() {
                          if (jQuery(this).val() == '')
                          {
                            jQuery('#my_admins').hide();
                            jQuery('#my_authors').hide();
                          }
                          else {
                            if (jQuery(this).val() == 'approve') {                              
                              jQuery('#my_authors').hide();
                              jQuery('#my_admins').show();
                              jQuery('#pluginsapproveandnotifycreatedUser').val(jQuery('#k2_user_name_plugins').val());
                            } else {
                            if (jQuery(this).val() == 'reject'){
                              jQuery('#my_authors').show();
                              jQuery('#my_admins').hide();
                              
                              jQuery('#pluginsapproveandnotifyauthorUser').val(jQuery('#k2_user_namereject_plugins').val());
                            }

                            }

                           }

                        });

                          jQuery('#k2_user_name_plugins').change(function() {
                           //  alert('ok');
                            jQuery('#pluginsapproveandnotifycreatedUser').val(jQuery('#k2_user_name_plugins').val());
                           });

                            jQuery('#k2_user_namereject_plugins').change(function() {
                                alert('ok');
                              jQuery('#pluginsapproveandnotifyauthorUser').val(jQuery('#k2_user_namereject_plugins').val());
                           });

                        
                        ";

              $output .= "</script>";

            $fields .= $output;
            
        }
    

        if ($fields)
        {

            
            $plugin = new stdClass;
            $plugin->name = $this->pluginNameHumanReadable;
            $plugin->fields = $fields;
            return $plugin;
        }
    }
        
    }

    //uber mail function!

    function onAfterK2Save(&$item, $isNew) {
      
      
        //jimport( 'joomla.application.application' );
        $mainframe = &JFactory::getApplication();
       
        if ($mainframe->isAdmin()) {

             $data = JRequest::getVar('plugins');             
             $action = $data['approveandnotifyaction_name_plugins'];
             $comment = $data['approveandnotifycomment'];
             $user_id = $data['approveandnotifycreatedUser']; //JRequest::getVar('createdUser');
             $author_id = $data['approveandnotifyauthorUser']; //JRequest::getVar('authorUser');
             $userCreated  = & JFactory::getUser((int)$user_id);
             $authorCreated  = & JFactory::getUser((int)$author_id);
             
             $emailall = $this->params->get('emailall', '');
             $emailonallsubs = $this->params->get('emailonallsubs', '0');

             if($action == "approve"){
              if($item->created_by != $userCreated->id){
              $titleEmail = "Approve Item : ".$item->title;
              $contentEmail = $comment;
              $mailer =& JFactory::getMailer();
              $mailer->isHTML(true);
              $mailer->setSubject($titleEmail);
              $mailer->setBody($contentEmail);
              
              if($emailonallsubs == "1"){
                 if ($emailall != '')
                {
        			     $addRecipient = explode(",",  $emailall);
                   $mailer->addRecipient($addRecipient);
                   $send =& $mailer->Send();                                                      
                }

              

              if($userCreated){
                 $item->created_by = $userCreated->id;
                 $secondMailer =& JFactory::getMailer();
                 $secondMailer->isHTML(true);
                 $secondMailer->setSubject($titleEmail);
                 $secondMailer->setBody($contentEmail);
                 $secondMailer->addRecipient($userCreated->email);
                 $send2 =& $secondMailer->Send();
                 echo "send email to admin and update owner";
               }
              $item->store();
              }
            }
             } else if($action == "reject"){

               
                if($authorCreated){
                  $item->created_by = $authorCreated->id;
                  $item->published = '0';
                  $titleEmail = "Rejected Item : ".$item->title;
                  $contentEmail = $comment;
                  $mailer =& JFactory::getMailer();
                  $mailer->isHTML(true);
                  $mailer->setSubject($titleEmail);
                  $mailer->setBody($contentEmail);
                  $mailer->addRecipient($authorCreated->email);
                  $send =& $mailer->Send();
                  $item->store();
                  echo "rejected mail";
                //  die;
                }
             }
           return; // Dont run in admin
        }
        
        if (!$item->store()) {
            
            $mainframe->redirect('index.php?option=com_k2&view=items', $item->getError(), 'error');
        }

       // check & load category email params for this submission
        
        JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
        $category = &JTable::getInstance('K2Category', 'Table');
        $category->load($item->catid);

        //check and fetch emails to notify
        $notifyparams = new JParameter($category->plugins);
		//echo '<pre>';print_r($notifyparams);echo '</pre>';exit;
		
        
        $emailall = $this->params->get('emailall', '');
		if ($emailall != '') 
		{

            //set mail object
            $mailer =& JFactory::getMailer();

            //set recipients
            //add
            $addRecipient = explode(",",  $emailall);
            $mailer->addRecipient($addRecipient);

            //get submission user info
            $user =& JFactory::getUser($item->created_by);

			//add title via submission type check eg edited or new
			$title = ($isNew == true) ? "New Submission:".$item->title : "Submission edited:".$item->title;
			$output='<h2>'.$title.'</h2>';
	
			//stuff data into output for passing to mail body
			$output.='<table>';     
			//user data
			$output.='<tr><td>From:</td><td>'.$user->name . '<'.$user->email.'></td></tr>';
	
			$approveurl = JURI::base().'administrator/index.php?option=com_k2&view=item&cid='.$item->id;
	
			$output.='<tr><td>Approve this URL here:</td><td><a href="'.$approveurl.'">Approve link</a></td></tr>';
			//get extrafield data for email body
			
					$itemID=JRequest::getInt('cid',NULL);
	
			JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
			$catid = $item->catid;
			$category = & JTable::getInstance('K2Category', 'Table');
			$category->load($catid);
	
			require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'extrafield.php');
			$extraFieldModel= new K2ModelExtraField;
	
			$extraFields = $extraFieldModel->getExtraFieldsByGroup($category->extraFieldsGroup);
					//var_dump($category->extraFieldsGroup);die();
	
	
			//var_dump($extraFields);
			   //get json lib for decode extrafields
				require_once(JPATH_ROOT.'/administrator/components/com_k2/lib/JSON.php');
				$json = new Services_JSON;
				$values = $json->decode($item->extra_fields);
				 if (!is_array($values)) continue;
					$output.='<table class="admintable" id="extraFields">';
			$counter=0;
			if (count($extraFields)){
	
						foreach ($extraFields as $extraField){
	
							$xf->name = plgK2approveandnotify::getXFVal($extraField->id,$value->value);
						   // var_dump($xf->name);
							 foreach($values as $value):
								//var_dump($value);
								if($value->value != "1"){
									if ($extraField->id == $value->id):
									   
										$output.='<tr><td align="left" class="key">'.$extraField->name.'</td>';
										$output.='<td>'.$value->value.$xf->name.'</td></tr>';
					
									endif;
								} /*else if($value->value === "1"){
									 if ($extraField->id == $value->id):
									$output.='<tr><td align="left" class="key">'.$extraField->name.'</td>';
										$output.='<td>-</td></tr>';
										endif;
								}*/
							 endforeach;
						}
			}
	
			$output.='</table>';        
			
				
	
	
			//set message up
			$body   = $output;
	
			$mailer->isHTML(true);
			$subject  = ($isNew == true) ? "Carers Week New Event Submission:" : "Carers Week Submission edited:";
			$mailer->setSubject($subject);
			$mailer->setBody($body);
	
			//send it
			$send =& $mailer->Send();
			if ( $send !== true ) {
			//    echo 'Error sending email: ' . $send->message;
			} else {
			  //  echo 'Mail sent';
			}
        }
      
    }

    function getXFVal($id,$currentValue){
                global $mainframe;
                $db = JFactory::getDBO();
		$db->setQuery('SELECT * FROM #__k2_extra_fields WHERE id = '.$id);
		$row =$db->loadObject();
//var_dump($row);
            require_once(JPATH_ROOT.'/administrator/components/com_k2/lib/JSON.php');
		$json=new Services_JSON;
		$jsonObject=$json->decode($row->value);

		$xfvalue='';$currentValue='';
		if ( $row->type=='textfield'|| $row->type=='textarea' || $row->type=='labels'){
			$xfvalue=$currentValue;
		}
		else if ($row->type=='multipleSelect'){
			foreach ($jsonObject as $option){
				if (in_array($option->value,$currentValue))
				$xfvalue.=$option->name.' ';
			}
		}
		else if ($row->type=='link'){
			$xfvalue.=$currentValue[0].' ';
			$xfvalue.=$currentValue[1].' ';
		}
		else
		{
			if (!is_array($jsonObject))return '';
			foreach ($jsonObject as $option){
				if ($option->value==$currentValue)
				$xfvalue.=$option->name;
			}
		}
                var_dump($xfvalue);//die();
		return $xfvalue;
    }
}
